/* REDUCE DE MPI */

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <sys/time.h>
#include <unistd.h>
#include <math.h>

/** ANADIDO **/
void empty_func(void *a, void *b, int *c, MPI_Datatype *d){}

main (argc, argv)
int             argc;
char            *argv[];
{
	int i, myrank, npes, size, localsize, iterations, pot2npes, pot2size;
	double startwtime = 0.0, endwtime, pot2npesd;
	char *mensaje, *mensaje2;
	long *vector,*vector2;
	MPI_Op EMPTY_OP;
			
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	MPI_Comm_size(MPI_COMM_WORLD, &npes);

	if (argc!=3) {
	if (!myrank) {printf("Error: mpirun -np 2 name size iterations \n");}
	exit(1);
	}else {

		size=atoi(argv[1]);
		iterations=atoi(argv[2]);
		localsize = size / npes;

        /** ANADIDO **/
        MPI_Op_create(&empty_func, 1, &EMPTY_OP);	
	
		vector=(long *)malloc((size_t) iterations*sizeof(long));
		vector2=(long *)malloc((size_t) iterations*sizeof(long));
		mensaje=(char *)malloc((size_t) size);
		mensaje2=(char *)malloc((size_t) size); 
		
		if ((mensaje==NULL)||(mensaje2==NULL)||(vector==NULL)||(vector2==NULL)) exit(9);

		pot2npes = (int)(log(npes)/0.69314718);
		pot2npesd = (double)(log(npes)/0.69314718);
		
		pot2size = (int)(log(size)/1.386294361);
		if (pot2size < 0) pot2size = 0;		
		

		for (i=0;i<iterations;i++) {
			MPI_Barrier(MPI_COMM_WORLD);
			startwtime = MPI_Wtime();
			MPI_Allreduce(mensaje2, mensaje, size,  MPI_CHAR, EMPTY_OP, MPI_COMM_WORLD);			
			endwtime =  MPI_Wtime();
			vector2[i] = (long) (1000000*(endwtime - startwtime));
		}

		MPI_Reduce(vector2, vector, iterations, MPI_LONG, MPI_MAX, 0, MPI_COMM_WORLD);

	/* Se visualiza: t(us) BW nPEs [log2(nPES)] log2(nPES) size log2(size)/2*/			
		if (myrank==0) {
			for(i=0;i<iterations;i++){
				printf("%.6lf \t %ld \t %.4lf \t %d \t %d \t %.4lf \t %d \t %d\n", (double) vector[i]/1000000, (long) vector[i],(double) size/vector[i], npes, pot2npes, pot2npesd, size, pot2size);
			}
        }
        /* stop operations of MPI routines */
        MPI_Finalize();
	}
}

