/* Barrier DE MPI */

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <sys/time.h>
#include <unistd.h>
#include <math.h>

main (argc, argv)
int             argc;
char            *argv[];
{
	int i, j, npes, myrank, iterations, pot2npes;
	double startwtime = 0.0, endwtime, pot2npesd;
	float *vector,*vector2;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	MPI_Comm_size(MPI_COMM_WORLD, &npes);

	iterations=atoi(argv[1]);

	if (argc!=2) {
	if (!myrank) {printf("Error: mpirun -np PES name iterations \n");}
	exit(1);
	}else {

	vector=(float *)malloc((size_t) iterations*sizeof(float));
	vector2=(float *)malloc((size_t) iterations*sizeof(float));

	if ((vector==NULL)||(vector2==NULL)) exit(9);

	pot2npes = (int)(log(npes)/0.69314718);
	pot2npesd = (double)(log(npes)/0.69314718);
	
	for (i=0;i<iterations;i++) {
    	MPI_Barrier(MPI_COMM_WORLD);
		startwtime = MPI_Wtime();
        MPI_Barrier(MPI_COMM_WORLD);
		endwtime =  MPI_Wtime();
        vector2[i] = (float) endwtime - startwtime;
	}

	MPI_Reduce(vector2, vector, iterations, MPI_FLOAT, MPI_MAX, 0, MPI_COMM_WORLD);

	if (myrank==0) {
		for(i=0;i<iterations;i++){
			printf("%.6lf \t %ld \t %d \t %d \t %.4lf\n", vector[i], (long) (1000000*vector[i]), npes, pot2npes, pot2npesd);
		}
	}
    
	/* stop operations of MPI routines */
	MPI_Finalize();
	}
}
