/* BROADCAST DE MPI */

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <sys/time.h>
#include <unistd.h>
#include <math.h>

main (argc, argv)
int             argc;
char            *argv[];
{
	int i, j, myrank, npes, size, iterations, pot2npes, pot2size;
	double startwtime = 0.0, endwtime, pot2npesd;
	char *mensaje;
	long *vector,*vector2;
	
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	MPI_Comm_size(MPI_COMM_WORLD, &npes);
	
	size=atoi(argv[1]);
	iterations=atoi(argv[2]);

	if (argc!=3) {
	if (!myrank) {printf("Error: mpirun -np 2 name size iterations \n");}
	exit(1);
	}else {

		vector=(long *)malloc((size_t) iterations*sizeof(long));
		vector2=(long *)malloc((size_t) iterations*sizeof(long));
		mensaje=(char *)malloc((size_t) size);
		
		if ((mensaje==NULL)||(vector==NULL)||(vector2==NULL)) exit(9);

		pot2npes = (int)(log(npes)/0.69314718);
		pot2npesd = (double)(log(npes)/0.69314718);
		
		pot2size = (int)(log(size)/1.386294361);
		if (pot2size < 0) pot2size = 0;		
		

		for (i=0;i<iterations;i++) {
		
			//for (j=0;j<size;j++) {
			//	mensaje[j] = 'a';
			//}		
			MPI_Barrier(MPI_COMM_WORLD);
			startwtime = MPI_Wtime();
			MPI_Bcast(mensaje, size, MPI_CHAR, 0, MPI_COMM_WORLD);
			endwtime =  MPI_Wtime();
			vector2[i] = (long) (1000000*(endwtime - startwtime));
		}

		MPI_Reduce(vector2, vector, iterations, MPI_LONG, MPI_MAX, 0, MPI_COMM_WORLD);

	/* Se visualiza: t(us) BW nPEs [log2(nPES)] log2(nPES) size log2(size)/2*/		
		if (myrank==0) {
			for(i=0;i<iterations;i++){
				printf("%.6lf \t %ld \t %.4lf \t %d \t %d \t %.4lf \t %d \t %d\n", (double) vector[i]/1000000, (long) vector[i],(double) size/vector[i], npes, pot2npes, pot2npesd, size, pot2size);
			}
        }
        /* stop operations of MPI routines */
        MPI_Finalize();
	}
}

