#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <sys/time.h>
#include <unistd.h>
#include <math.h>

main (argc, argv)
int             argc;
char            *argv[];
{
	int i, myrank, size, iterations, pot2size;
	MPI_Status status;
	double startwtime = 0.0, endwtime;
	char *mensaje, *buffer;
	long time;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);

	size=atoi(argv[1]);
	iterations=atoi(argv[2]);

	if (argc!=3) {
		if (!myrank) {printf("Error: mpirun -np 2 name size iterations \n");}
		exit(1);
	} else {
	
		
		mensaje=(char *)malloc((size_t) size);
		
		buffer=(char *)malloc((size_t) size + MPI_BSEND_OVERHEAD);	
			
		if ((mensaje==NULL)||(buffer==NULL)) exit(9);

		MPI_Buffer_attach(buffer, size + MPI_BSEND_OVERHEAD);
		
		pot2size = (int)(log(size)/1.386294361);
		if (pot2size < 0) pot2size = 0;

		MPI_Barrier(MPI_COMM_WORLD);		
		if (myrank == 0) { /*Proceso 0 */
			for (i=0;i<iterations;i++){
				startwtime = MPI_Wtime();
				MPI_Bsend(mensaje,size,MPI_CHAR,1,0,MPI_COMM_WORLD);
				MPI_Recv(mensaje,size,MPI_CHAR,1,0,MPI_COMM_WORLD,&status);
				endwtime = MPI_Wtime();
				time = (long) 500000*(endwtime - startwtime);
				printf("%.6lf \t %ld \t %.4lf \t %d \t %d\n",(double) time/1000000, time,(double) size/time, size, pot2size);
			}
		} else {  /* Proceso 1 */
			for (i=0;i<iterations;i++){
				MPI_Recv(mensaje,size,MPI_CHAR,0,0,MPI_COMM_WORLD,&status);
				MPI_Bsend(mensaje,size,MPI_CHAR,0,0,MPI_COMM_WORLD);
            }
		}
        /* stop operations of MPI routines */
       MPI_Finalize();
	} 
}

